<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>iipsrv: Writer.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="iip.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">iipsrv
   &#160;<span id="projectnumber">1.1</span>
   </div>
   <div id="projectbrief">iipsrv is an advanced high-performance feature-rich image server for web-based streamed viewing and zooming of ultra high-resolution images</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('Writer_8h_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">Writer.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">    IIP Generic Output Writer Classes</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">    Copyright (C) 2006-2013 Ruven Pillay.</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">    This program is free software; you can redistribute it and/or modify</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">    it under the terms of the GNU General Public License as published by</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">    the Free Software Foundation; either version 3 of the License, or</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">    (at your option) any later version.</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">    This program is distributed in the hope that it will be useful,</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">    GNU General Public License for more details.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">    You should have received a copy of the GNU General Public License</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">    along with this program; if not, write to the Free Software Foundation,</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">    Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#ifndef _WRITER_H</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#define _WRITER_H</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;fcgiapp.h&gt;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;cstdio&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="classWriter.html">   31</a></span>&#160;<span class="keyword">class </span><a class="code" href="classWriter.html">Writer</a> {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; <span class="keyword">public</span>:</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;  <span class="keyword">virtual</span> ~<a class="code" href="classWriter.html">Writer</a>() = 0;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="classWriter.html#a74d4dbbaa7d23df5c7750e0d579d5521">putStr</a>( <span class="keyword">const</span> <span class="keywordtype">char</span>* msg, <span class="keywordtype">int</span> len ) = 0;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="classWriter.html#ac20600c328ab19ebe4ea7e31df8c59a2">putS</a>( <span class="keyword">const</span> <span class="keywordtype">char</span>* msg ) = 0;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="classWriter.html#ade3b6b89d3e35720c80f4f71c1fde9b7">printf</a>( <span class="keyword">const</span> <span class="keywordtype">char</span>* msg ) = 0;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="classWriter.html#a53cbf2e1aa8ababe1258e768bd76e970">flush</a>() = 0;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;};</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="classFCGIWriter.html">   59</a></span>&#160;<span class="keyword">class </span><a class="code" href="classFCGIWriter.html">FCGIWriter</a> {</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; <span class="keyword">private</span>:</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;  </div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  FCGX_Stream *out;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;  <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bufsize = 65536;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;  <span class="keywordtype">void</span> cpy2buf( <span class="keyword">const</span> <span class="keywordtype">char</span>* msg, <span class="keywordtype">size_t</span> len ){</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordflow">if</span>( sz+len &gt; bufsize ) buffer = (<span class="keywordtype">char</span>*) realloc( buffer, sz+len );</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordflow">if</span>( buffer ){</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;      memcpy( &amp;buffer[sz], msg, len );</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;      sz += len;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    }</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;  };</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; <span class="keyword">public</span>:</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;  <span class="keywordtype">char</span>* buffer;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;  <span class="keywordtype">size_t</span> sz;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno"><a class="line" href="classFCGIWriter.html#aadea2e2f6b31969c257c1a0b1e06fc0b">   83</a></span>&#160;  <a class="code" href="classFCGIWriter.html#aadea2e2f6b31969c257c1a0b1e06fc0b">FCGIWriter</a>( FCGX_Stream* o ){</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    out = o;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    buffer = (<span class="keywordtype">char</span>*) malloc(bufsize);</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    sz = 0;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;  };</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="classFCGIWriter.html#a8a24836245d2f9392fcab8fc5b1d71a8">   90</a></span>&#160;  <a class="code" href="classFCGIWriter.html#a8a24836245d2f9392fcab8fc5b1d71a8">~FCGIWriter</a>(){ <span class="keywordflow">if</span>(buffer) free(buffer); };</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;  <span class="keywordtype">int</span> putStr( <span class="keyword">const</span> <span class="keywordtype">char</span>* msg, <span class="keywordtype">int</span> len ){</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    cpy2buf( msg, len );</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="keywordflow">return</span> FCGX_PutStr( msg, len, out );</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;  };</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;  <span class="keywordtype">int</span> putS( <span class="keyword">const</span> <span class="keywordtype">char</span>* msg ){</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    cpy2buf( msg, strlen(msg) );</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="keywordflow">return</span> FCGX_PutS( msg, out );</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;  }</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;  <span class="keywordtype">int</span> printf( <span class="keyword">const</span> <span class="keywordtype">char</span>* msg ){</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    cpy2buf( msg, strlen(msg) );</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordflow">return</span> FCGX_FPrintF( out, msg );</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;  };</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;  <span class="keywordtype">int</span> flush(){</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keywordflow">return</span> FCGX_FFlush( out );</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;  };</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;};</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno"><a class="line" href="classFileWriter.html">  113</a></span>&#160;<span class="keyword">class </span><a class="code" href="classFileWriter.html">FileWriter</a> {</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160; <span class="keyword">private</span>:</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;  FILE* out;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160; <span class="keyword">public</span>:</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;  <a class="code" href="classFileWriter.html">FileWriter</a>( FILE* o ){ out = o; };</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;  <span class="keywordtype">int</span> putStr( <span class="keyword">const</span> <span class="keywordtype">char</span>* msg, <span class="keywordtype">int</span> len ){</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keywordflow">return</span> fwrite( (<span class="keywordtype">void</span>*) msg, <span class="keyword">sizeof</span>(<span class="keywordtype">char</span>), len, out );</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;  };</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;  <span class="keywordtype">int</span> putS( <span class="keyword">const</span> <span class="keywordtype">char</span>* msg ){</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="keywordflow">return</span> fputs( msg, out );</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;  }</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;  <span class="keywordtype">int</span> printf( <span class="keyword">const</span> <span class="keywordtype">char</span>* msg ){</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="keywordflow">return</span> fprintf( out, <span class="stringliteral">&quot;%s&quot;</span>, msg );</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;  };</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;  <span class="keywordtype">int</span> flush(){</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keywordflow">return</span> fflush( out );</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;  };</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;};</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;  </div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classWriter_html"><div class="ttname"><a href="classWriter.html">Writer</a></div><div class="ttdoc">Virtual base class for various writers. </div><div class="ttdef"><b>Definition:</b> Writer.h:31</div></div>
<div class="ttc" id="classWriter_html_ade3b6b89d3e35720c80f4f71c1fde9b7"><div class="ttname"><a href="classWriter.html#ade3b6b89d3e35720c80f4f71c1fde9b7">Writer::printf</a></div><div class="ttdeci">virtual int printf(const char *msg)=0</div><div class="ttdoc">Write out a string. </div></div>
<div class="ttc" id="classWriter_html_ac20600c328ab19ebe4ea7e31df8c59a2"><div class="ttname"><a href="classWriter.html#ac20600c328ab19ebe4ea7e31df8c59a2">Writer::putS</a></div><div class="ttdeci">virtual int putS(const char *msg)=0</div><div class="ttdoc">Write out a string. </div></div>
<div class="ttc" id="classWriter_html_a53cbf2e1aa8ababe1258e768bd76e970"><div class="ttname"><a href="classWriter.html#a53cbf2e1aa8ababe1258e768bd76e970">Writer::flush</a></div><div class="ttdeci">virtual int flush()=0</div><div class="ttdoc">Flush the output buffer. </div></div>
<div class="ttc" id="classFileWriter_html"><div class="ttname"><a href="classFileWriter.html">FileWriter</a></div><div class="ttdoc">File Writer Class. </div><div class="ttdef"><b>Definition:</b> Writer.h:113</div></div>
<div class="ttc" id="classFCGIWriter_html_a8a24836245d2f9392fcab8fc5b1d71a8"><div class="ttname"><a href="classFCGIWriter.html#a8a24836245d2f9392fcab8fc5b1d71a8">FCGIWriter::~FCGIWriter</a></div><div class="ttdeci">~FCGIWriter()</div><div class="ttdoc">Destructor. </div><div class="ttdef"><b>Definition:</b> Writer.h:90</div></div>
<div class="ttc" id="classWriter_html_a74d4dbbaa7d23df5c7750e0d579d5521"><div class="ttname"><a href="classWriter.html#a74d4dbbaa7d23df5c7750e0d579d5521">Writer::putStr</a></div><div class="ttdeci">virtual int putStr(const char *msg, int len)=0</div><div class="ttdoc">Write out a binary string. </div></div>
<div class="ttc" id="classFCGIWriter_html"><div class="ttname"><a href="classFCGIWriter.html">FCGIWriter</a></div><div class="ttdoc">FCGI Writer Class. </div><div class="ttdef"><b>Definition:</b> Writer.h:59</div></div>
<div class="ttc" id="classFCGIWriter_html_aadea2e2f6b31969c257c1a0b1e06fc0b"><div class="ttname"><a href="classFCGIWriter.html#aadea2e2f6b31969c257c1a0b1e06fc0b">FCGIWriter::FCGIWriter</a></div><div class="ttdeci">FCGIWriter(FCGX_Stream *o)</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> Writer.h:83</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><b>Writer.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.14 </li>
  </ul>
</div>
</body>
</html>
